import 'dart:io';

import 'package:jt_flutter_cli/core/const/string_const.dart';
import 'package:jt_flutter_cli/core/util/model_util/helpers.dart';
import 'package:jt_flutter_cli/core/util/model_util/model_generator.dart';
import 'package:jt_flutter_cli/core/util/util.dart';

import '../../core/path/path_handler.dart';

class CreateModel {
  void generateDartModel({
    required String modelName,
    required String featureName,
    required String jsonFilePath,
    bool isModelForAPI = true,
  }) {
    try {
      final jsonString = File(jsonFilePath).readAsStringSync();
      DartCode dartCode =
          ModelGenerator(camelCase(modelName)).generateDartClasses(jsonString);

      final outputFileName = '$modelName$kDart';
      Utility.createFolder(
        path: PathHandler().getModelPath(
          featureName: featureName,
        ),
      );
      File(
        "${PathHandler().getModelPath(featureName: featureName)}/$outputFileName",
      ).writeAsStringSync(dartCode.code);
      if (!isModelForAPI) {
        Utility.successPrinter(text: '$kModelSuccessMessage $outputFileName');
      }
    } catch (e) {
      Utility.errorPrinter(text: '$kError $kModelErrorMessage\n$e');
      exit(1);
    }
  }
}
